package ZipTie::Adapters::CheckPoint::CPSMS::FileUtilities;

use strict;
use warnings;

use ZipTie::Logger;

use Exporter 'import';
our @EXPORT_OK = qw(getFileToString getFilePath);

# Get the instance of the ZipTie::Logger module
my $LOGGER = ZipTie::Logger::get_logger();


sub getFileToString
{
	my ($filename, $appdir ) = @_;
	
	# get package's path 
	( my $pkgDir = __PACKAGE__ ) =~ s!::!/!g;
	my ($pkgPath) = $INC{"$pkgDir.pm"} =~ m!^(.+)/!;
	
	
	my $file = $pkgPath."/".$appdir."/".$filename;
	my $wholeFile;
	
	# slurp the entire file at once
	my $lineEnding = $/;
	undef $/;   
	
	$LOGGER->debug("Reading $file");
	open (FILE, $file) or $LOGGER->fatal_error_code("Error: readWholeFile: File is not available: $file");
	$wholeFile = <FILE>;
	# close FILE handler and restore lineEnding
	close (FILE);
	# restore the lineEnding
	$/ = $lineEnding;
	
	my $restore = eval "my $wholeFile";
	return $restore;   
}

sub getFilePath
{
	my ($filename, $appdir ) = @_;
	
	# get package's path 
	( my $pkgDir = __PACKAGE__ ) =~ s!::!/!g;
	my ($pkgPath) = $INC{"$pkgDir.pm"} =~ m!^(.+)/!;
	
	my $filePath;
	if (($filename =~ /rec/) or ($filename =~ /implied_rules/)){
		$filePath = $appdir."/".$filename;
	} else {
		$filePath = $pkgPath."/".$appdir."/".$filename;
	}
	
	return $filePath;   
}

1;
