package ZipTie::Adapters::Juniper::NSM::NsmElf;

use strict;
use warnings;

use ZipTie::Logger;

use Exporter 'import';
our @EXPORT_OK =
  qw(get_attack_group_refs get_array);

my $LOGGER = ZipTie::Logger::get_logger();

sub get_attack_group_refs
{
    my ($rule) = @_;

    my @refids = ();

    foreach my $attack (get_array($rule, 'attacks', 'attack_list_collection', 'attack_list'))
    {
        push(@refids, $attack->{name_});
    }

    return @refids;
}

sub get_array
{
    my $obj = shift or $LOGGER->fatal("undef passed to get_array");

    my $current = $obj;
    foreach my $prop (@_)
    {
        return () unless defined $current->{$prop};

        $current = $current->{$prop};
    }

    return @$current;
}
1;
