#!/usr/bin/perl

use strict;
use Digest::MD5 qw(md5_hex);
use Data::Dumper;

my @srcLines = ();

# Test to allow a filename on the command line, or piped input via STDIN from some other
# program or process context.
#
if (0 > $#ARGV) {
	if (-t STDIN) 
	{
		die "Usage: $0 (filename)";
	} 	   
	@srcLines = <STDIN>;
}
else
{
	open SIGSRC, "<$ARGV[0]" || die "Unable to find or open $ARGV[0]";
	my @srcLines = <SIGSRC>;
}

my $contentBuf = join "", @srcLines;
my $content = md5_hex($contentBuf);

my $sigBuf = "";

print "Raw signature is \'$content\', length " . length($content) . "\n";

for (my $i = 0; $i < length($content)/2; $i += 2) {
   my $sigByte = hex(substr($content, $i, 2)) ^  hex(substr($content, $i + (length($content)/2), 2));
   $sigBuf .= sprintf("%02x", $sigByte);
}

print "Ziptie Signature is \'$sigBuf\', length " . length($sigBuf) . "\n";
exit(0);

__END__

=head1 NAME

signatureTest.pl

=head1 SYNOPSIS

    signatureTest.pl (filename)
      or
    (command) | signatureTest.pl
=cut

